package ru.amse.rakkate.crossword.logic;

import java.util.List;
import java.util.LinkedList;
import javax.print.attribute.Size2DSyntax;

public class Task implements ITask{
    private  List<Integer> myRowArray[];
    private  List<Integer> myCoulumnArray[];
    private int myMaxRow = 0;
    private int myMaxCoulumn = 0;
    private final int myWidth;
    private final int myHeight;
    
    public Task(int height, int width) {
        myWidth = width;
        myHeight = height;
        myRowArray =  newList(myRowArray, myHeight);
        myCoulumnArray = newList(myCoulumnArray, myWidth);
    }
    
    public int getMaxBlock(List<Integer> list) {
        int k = 0;
        for (int i: list) {
            if (i > k) {
                k = i;
            }
        }
        return k;
    }
    
    public List<Integer>[] newList(List<Integer> list[], int size) {
        list = new List[size];
        for (int i = 0; i < size; i++) {
            list[i] = new LinkedList<Integer>();
        }
        return list;
    }
    
    public int getMaxRow() {
        return myMaxRow;
    }
    
    public int getMaxCoulumn() {
        return myMaxCoulumn;
    }
    
    public List<Integer>[] getRowArray() {
        return myRowArray;
    }
    
    public List<Integer>[] getCoulumnArray() {
        return myCoulumnArray;
    }
    
    public int getQuantityBlocksRow(int x) {
        return myRowArray[x].size();
    }
    
    public int getQuantityBlocksCoulumn(int x) {
        return myCoulumnArray[x].size();
    }
    
    public int getBlockRow(int x, int y) {
        return myRowArray[x].get(y);
    }
    
    public int getBlockCoulumn(int x, int y) {
        return myCoulumnArray[x].get(y);
    }
    
    public void addBlockRow(int x, int block) {
        myRowArray[x].add(block);
        if (myMaxRow < myRowArray[x].size()) {
            myMaxRow = myRowArray[x].size();
        }
    }
    
    public void addBlockCoulumn(int x, int block) {
        myCoulumnArray[x].add(block);
        if (myMaxCoulumn < myCoulumnArray[x].size()) {
            myMaxCoulumn = myCoulumnArray[x].size();
        }
    }
    
    public int getHeight() {
        return myHeight;
    }
    
    public int getWidth() {
        return myWidth;
    }
    
    public boolean getResultArray(List<IBlock> listBlock, List<Integer> taskRow) {
        List<Integer> list = new LinkedList<Integer>();
        for(IBlock block: listBlock) {
            list.add(block.getEnd() - block.getStart() + 1);
        }
        if (list.equals(taskRow)) {
            return true;
        } else {
            return false;
        }
    }
    
    public boolean getResult(IMap map) {
        boolean result = true;
        for (int i = 0; i < map.getHeight(); i++) {
            if (result) {
                result = getResultArray(map.getBlocksByRow(i), myRowArray[i]);
            } else {
                result =  false;
                break;
            }
        }
        for (int i = 0; i < map.getWidth(); i++) {
            if (result) {
                result = getResultArray(map.getBlocksByCoulumn(i), myCoulumnArray[i]);
            } else {
                result = false;
                break;
            }
        }     
        return result;
    }
}