package ru.amse.rakkate.crossword.logic.loadsave;

import java.io.*;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.*;
import ru.amse.rakkate.crossword.logic.*;
import ru.amse.rakkate.crossword.ui.main.MapView;

public class MapReader {
    
    private IMap myMap;
    
    public IMap readerMap(InputStream r) throws IOException, SAXException, ParserConfigurationException {
        SAXParserFactory factory = SAXParserFactory.newInstance();
        SAXParser p = factory.newSAXParser(); 
        p.parse(r, new MyDefaultHandlerMap());
        return myMap;
    }
    
    private class MyDefaultHandlerMap extends DefaultHandler {
        private int myRowCount = 0;
        private int squareCount = 0;
        private State myState;
        
        public void startElement(String uri, String localName, String rawName, Attributes a) throws SAXException {
            myState = State.valueOf(rawName.toUpperCase());
            switch (myState) {
                case MAP: 
                    int height = Integer.valueOf(a.getValue("height"));
                    int width = Integer.valueOf(a.getValue("width"));
                    myMap = new Map(width, height);
                    break;
                case ROW: 
                    myRowCount++;
                    squareCount = 0;
                    break;
                case SQUARE:
                    squareCount++;
            }
        }
            
        public void characters(char[] ch, int start, int lenght) throws SAXException {
            String value = new String(ch, start, lenght);
            if (!Character.isISOControl(value.charAt(0))) {
                if (myState == State.SQUARE) {
                    if (value.equals("BLACK")) {
                        myMap.setCell(squareCount - 1, myRowCount - 1, Square.BLACK);
                    } else if (value.equals("POINT")) {
                        myMap.setCell(squareCount - 1, myRowCount - 1, Square.POINT);
                    }
                }
            }
        }
    }
    
}
