package ru.amse.rakkate.crossword.logic.loadsave;

import java.io.*;
import java.io.FileReader;
import ru.amse.rakkate.crossword.logic.IMap;
import ru.amse.rakkate.crossword.logic.Map;
import ru.amse.rakkate.crossword.logic.Square;
import java.util.List;
import java.util.LinkedList;
import java.util.ArrayList;

public class TXTReader {
    
    public void readeTXT(Reader f, FileWriter w) throws IOException, SecurityException, FileNotFoundException {
        List<List<Boolean>> map = new ArrayList<List<Boolean>>();
        try{
            int s;
            List<Boolean> mapRow = new ArrayList<Boolean>();
            int index = 0;
            int width = 0;
            do {
                s = f.read();
                if (s == 88) {
                    mapRow.add(true);
                } else if (s == 32) {
                    mapRow.add(false);
                } else if ((s == 10) || (s == -1)) {
                    map.add(index, mapRow);
                    if (width < mapRow.size()) {
                        width = mapRow.size();
                    }
                    index++;
                    mapRow = new ArrayList<Boolean>();
                }
            } while (s != -1);
            List<Integer> taskRow[] = getTaskRow(map);
            List<Integer> taskCoulumn[] = getTaskCoulumn(map, width);
            int height = map.size();
            XMLWriterTask writer = new XMLWriterTask();            
            writer.writeXML(w, width, height, taskRow, taskCoulumn);
        } finally {
            if (f != null) {
                f.close();
            }
            if (w != null) {
                w.close();
            }
        }
    }
    
    public List<Integer>[] getTaskRow(List<List<Boolean>> map) {
        List<Integer> taskRow[] = new List[map.size()];
        List<Boolean> mapRow = new ArrayList<Boolean>();
        for (int i = 0; i < map.size(); i++) {
            taskRow[i] = new LinkedList<Integer>();
            int index = 0;
            mapRow = map.get(i);
            for (int j = 0; (j < mapRow.size()); j++) {
                if (mapRow.get(j) == true) {
                    if ((j > 0 ) && (mapRow.get(j - 1) == true)) {
                        taskRow[i].set((index - 1), (taskRow[i].get(index - 1) + 1));
                    } else {
                        taskRow[i].add(1);
                        index++;
                    }
                }
            }
        }
        return taskRow;
    }
    
    public List<Integer>[] getTaskCoulumn(List<List<Boolean>> map, int width) {
        List<Integer> taskCoulumn[] = new List[width];
        List<Boolean> mapRow = new ArrayList<Boolean>();
        List<Boolean> nextMapRow = new ArrayList<Boolean>();
        for (int i = 0; i < width; i++) {
            taskCoulumn[i] = new LinkedList<Integer>();
            int ind = 0;
            for ( int j = 0; j < map.size(); j++) {
                mapRow = map.get(j);
                if(mapRow.size() == i) {
                    mapRow.add(false);
                }
                if (mapRow.get(i) == true) {
                    if (j > 0) {
                        nextMapRow = map.get(j - 1);
                        if (nextMapRow.get(i) == true) {
                            taskCoulumn[i].set((ind - 1), (taskCoulumn[i].get(ind - 1) + 1));
                        } else {
                            taskCoulumn[i].add(1);
                            ind++;
                        }
                    } else {
                        taskCoulumn[i].add(1);
                        ind++;
                    }
                }
            }
        }
        return taskCoulumn;
    }
}


