package ru.amse.rakkate.crossword.logic.loadsave;

import java.io.*;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.*;
import ru.amse.rakkate.crossword.logic.*;
import ru.amse.rakkate.crossword.ui.main.MapView;


public class TaskReader {
    private ITask myTask;
    private String myTaskName;
    
    public ITask reader(InputStream r) throws IOException, SAXException, ParserConfigurationException { 
            SAXParserFactory f = SAXParserFactory.newInstance();
            SAXParser p = f.newSAXParser();
            p.parse(r, new MyDefaultHandler());
            return myTask; 
    }
    
    private class MyDefaultHandler extends DefaultHandler {
        private int myRowCount = 0;
        private int myCoulumnCount = 0;
        private State myState;
        
        public void startElement(String uri, String localName, String rawName, Attributes a) throws SAXException {
            myState = State.valueOf(rawName.toUpperCase());
            switch (myState) {
                case TASK: 
                    int height = Integer.valueOf(a.getValue("height"));
                    int width = Integer.valueOf(a.getValue("width"));
                    myTask = new Task(height, width);
                    break;
                case COULUMN: 
                    myCoulumnCount++;
                    break;
                case ROW: 
                    myRowCount++;
                    break;
            }
        }
               
        public void characters(char[] ch, int start, int lenght) throws SAXException {
            String value = new String(ch, start, lenght);
            if (!Character.isISOControl(value.charAt(0))) {
                int block = Integer.valueOf(value);
                if (myState == State.ROW_BLOCK) {
                    myTask.addBlockRow((myRowCount - 1), block);
                } else if(myState == State.COULUMN_BLOCK) {
                    myTask.addBlockCoulumn((myCoulumnCount - 1), block);
                }
            }
        }
    }
    
   
    
    public String readerNameTask(InputStream r) throws IOException, SAXException, ParserConfigurationException, FileNotFoundException {
        SAXParserFactory factory = SAXParserFactory.newInstance();
        SAXParser p = factory.newSAXParser(); 
        p.parse(r, new MyDefaultHandlerTask());
        return myTaskName;
    }
    
    private class MyDefaultHandlerTask extends DefaultHandler {
        private State myState;
        
        public void startElement(String uri, String localName, String rawName, Attributes a) throws SAXException {
            myState = State.valueOf(rawName.toUpperCase());
            switch (myState) {
                case MAP:
                    myTaskName = a.getValue("taskfile");
                    break;
            }
        }
    }
}
    
