package ru.amse.rakkate.crossword.logic.loadsave;

import java.io.*;
import java.io.FileReader;
import ru.amse.rakkate.crossword.logic.IMap;
import ru.amse.rakkate.crossword.logic.Map;
import ru.amse.rakkate.crossword.logic.Square;
import java.util.List;
import java.util.LinkedList;
import java.util.ArrayList;

public class XMLWriterMap {
    
    public void writeMap(FileWriter w, IMap myMap, String myNameFile, boolean flag) throws IOException {
        w.write("<?xml version = \"1.0\" encoding =\"UTF-8\" ?>\n");
        if (flag) {
            w.write("<map taskfile = \"" + myNameFile + "\" width  = \"" + myMap.getWidth() + "\" height = \"" + myMap.getHeight() + "\">\n");
        } else {
            w.write("<map width  = \"" + myMap.getWidth() + "\" height = \"" + myMap.getHeight() + "\">\n");    
        }
        int width = myMap.getWidth();
        int height = myMap.getHeight();
        w.write("<rows>");
        for (int i = 0; i < height; i++ ) {
           w.write("<row>");
           for (int j = 0; j < width; j++) {
               Square square = myMap.getCell(j, i);
                w.write("<square>" + square + "</square>");
            }
            w.write("</row>");
        }
        w.write("</rows>");
        w.write("</map>");    
    }
    
}
