package ru.amse.rakkate.crossword.ui;

import ru.amse.rakkate.crossword.logic.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public abstract class View extends JPanel {
    
    private static final int MYRADIUSPOINT = 3;
    protected IMap myMap;
    protected ITask myTask;
    protected boolean myIsChanged = false;
    protected int mySize;
           
    public void setTaskandMap(ITask t, IMap m, int size) {
        mySize = size;
        myTask = t;
        myMap = m;
        Dimension dimension = new Dimension(mySize * (myMap.getWidth() + myTask.getMaxRow() + 2), mySize * (myMap.getHeight() + myTask.getMaxCoulumn() + 2));
        setSize(dimension);
        setPreferredSize(dimension);
    }
     
    public boolean getIsChanged() {
        return myIsChanged;
    }
    
   public void paintComponent(Graphics g) {
        int height = myMap.getHeight();
        int width = myMap.getWidth();
        drawMap(g, height, width);
    }
    
    public void drawMap(Graphics g, int height, int width) {
        
        g.drawRect(mySize, mySize, (width + myTask.getMaxRow()) * mySize, (height + myTask.getMaxCoulumn()) * mySize);
        g.fillRect(mySize, (mySize + (myTask.getMaxCoulumn() * mySize) - 1), (width + myTask.getMaxRow()) * mySize, 2);
        g.fillRect((mySize + (myTask.getMaxRow() * mySize) - 1), mySize, 2, (height + myTask.getMaxCoulumn()) * mySize);
        int left = mySize + (myTask.getMaxRow() * mySize);
        int top = mySize + (myTask.getMaxCoulumn() * mySize);
        for (int i = 0; i < width; i++) {
            for (int j = 0; j < height; j++) {
                if (myMap.getCell(i, j) == Square.BLACK) {
                    g.fillRect((left + (i * mySize)), (top + (j * mySize)), mySize, mySize);
                } else if (myMap.getCell(i,j) == Square.EMPTY) {
                    g.clearRect((left + (i * mySize)), (top + (j * mySize)), mySize, mySize);
                    g.drawRect((left + (i * mySize)), (top + (j * mySize)), mySize, mySize);
                } else {
                    g.drawRect((left + (i * mySize)), (top + (j * mySize)), mySize, mySize);
                    g.fillOval((left + (i * mySize) + ((mySize - MYRADIUSPOINT) / 2)), ((top + (j * mySize) + ((mySize - MYRADIUSPOINT + 2) / 2))), MYRADIUSPOINT, MYRADIUSPOINT);
                }
            }
        }
    }
    
    public void setUnchanged() {
        myIsChanged = false;
    }
    
}
