package ru.amse.rakkate.crossword.ui.editor;

import ru.amse.rakkate.crossword.logic.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.applet.*;
import ru.amse.rakkate.crossword.ui.*;

public class EditorView extends View {
   
    public EditorView(IMap m, ITask t,  int size) {
        mySize = size;
        myMap = m;
        myTask = t;
        addMouseListener(new MyMouseAdapter());
    }

    
    
    public void paintComponent(Graphics g) {
       super.paintComponent(g);   
    }
    
    private class MyMouseAdapter extends MouseAdapter {
        
        public void mouseClicked(MouseEvent me) {
            int x = me.getX();
            int y = me.getY();
            int left = mySize;
            int top = mySize;
            int i = (x - left) / mySize;
            int j = (y - top) / mySize;
            if ((i >= 0) && ((x - left) >= 0) && ((y - top)>= 0) && (i < myMap.getWidth()) && (j >= 0) && (j < myMap.getHeight())) {
                myIsChanged = true;
                switch(myMap.getCell(i, j)) {
                    case BLACK:
                        myMap.setCell(i, j, Square.EMPTY);
                        break;
                    case EMPTY:
                        myMap.setCell(i, j, Square.BLACK);
                        break;          
                }
                repaint();
            }
        }
    }
}
