package ru.amse.rakkate.crossword.ui.main;

import ru.amse.rakkate.crossword.logic.IMap;
import ru.amse.rakkate.crossword.logic.IMap;
import ru.amse.rakkate.crossword.logic.Square;
import ru.amse.rakkate.crossword.logic.Task;
import ru.amse.rakkate.crossword.logic.ITask;
import ru.amse.rakkate.crossword.logic.IBlock;
import java.util.List;
import java.util.LinkedList;
import javax.swing.*;
import java.awt.*;
import java.awt.geom.Rectangle2D;
import java.awt.event.*;
import ru.amse.rakkate.crossword.ui.*;

public class MapView extends View {
    
   public MapView(IMap m, ITask t, int size) {
        myMap = m;
        myTask = t;
        mySize = size;
        addMouseListener(new MyMouseAdapter());
    }
    
   
    public void drawTaskCoulumn(Graphics g, int width) {
        int left = mySize + (myTask.getMaxRow() * mySize);
        int top = mySize + (myTask.getMaxCoulumn() * mySize);
        int k = 0;
        List<Integer> listCoulumn[] = myTask.getCoulumnArray();
        Font f = g.getFont();
        int size = f.getSize();
        for (int i = 0; i < width; i++ ) {
            for(int j: listCoulumn[i]) {
                g.drawRect((left + mySize * i),(top - (mySize * (k + 1))), mySize, mySize);
                String s = j + "";
                Rectangle2D rec = g.getFontMetrics().getStringBounds(s, g);
                int lenghtString = (int)rec.getMaxX() - (int)rec.getMinX();
                g.drawString(s, (left + mySize * i  + (mySize - lenghtString) / 2),(top - ((mySize - (mySize - lenghtString)/2 + 1) / 2) - mySize * (listCoulumn[i].size() - k - 1)));
                 k++;
            }
            k = 0;
        }
    }
    
    public void drawTaskRow(Graphics g, int height) {
        int left = mySize + (myTask.getMaxRow() * mySize);
        int top = mySize + (myTask.getMaxCoulumn() * mySize);
        Font f = g.getFont();
        int size = f.getSize();
        int k = 0;
        List<Integer> listRow[] = myTask.getRowArray();
        for( int i = 0; i < height; i++) {
            for(int j: listRow[i]) {
                g.drawRect((left - (((listRow[i].size() - k) * mySize))),(top + mySize * i), mySize, mySize);
                String s = j + "";
                Rectangle2D rec = g.getFontMetrics().getStringBounds(s, g);
                int lenghtString = (int)rec.getMaxX() - (int)rec.getMinX();
                g.drawString(s, (left - ((listRow[i].size() - k) * mySize) + (mySize - lenghtString - 1) / 2), (top + mySize * i + (2 * mySize - size  - 1) / 2));
                k++;
            }
            k = 0;
        }
    }
    
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        int height = myMap.getHeight();
        int width = myMap.getWidth();
        drawTaskCoulumn(g, width);
        drawTaskRow(g, height);
    }
    
    private class MyMouseAdapter extends MouseAdapter {
        
        public void mouseClicked(MouseEvent me) {
            int x = me.getX();
            int y = me.getY();
            int left = mySize + (myTask.getMaxRow() * mySize);
            int top = mySize + (myTask.getMaxCoulumn() * mySize);  
            int i = (x - left) / mySize;
            int j = (y - top) / mySize;
            if ((i >= 0) && ((x - left) >= 0) && ((y - top)>= 0) && (i < myMap.getWidth()) && (j >= 0) && (j < myMap.getHeight())) {
                if ((myTask.getWidth() == 0) & (myTask.getHeight() == 0)) {
                    switch(myMap.getCell(i, j)) {
                        case BLACK:
                            myMap.setCell(i, j, Square.EMPTY);
                            break;
                        case EMPTY:
                            myMap.setCell(i, j, Square.BLACK);
                            break;          
                    }
                } else {
                    myIsChanged = true;
                    switch(myMap.getCell(i, j)) {
                        case POINT:
                            if ((myMap.controlQuantity(i, j, myTask) && (myMap.controlMaximum(i, j, myTask)))) {
                                myMap.setCell(i, j, Square.BLACK);
                            } else {
                                myMap.setCell(i, j, Square.EMPTY);
                            }
                            break;
                        case BLACK:
                            myMap.setCell(i, j, Square.EMPTY);
                            break;
                        case EMPTY:
                            myMap.setCell(i, j, Square.POINT);
                            break;          
                    }
                }
            }
            repaint();
        }
    }
    
}
